<template>
  <div v-if="filteredGameEntrySelected.length > 0 || gameEntrySelected.length > 0" class="lg:mb-10 mb-96 !w-full">
    <div v-for="(game, index) in (isSport ? gameEntrySelected : filteredGameEntrySelected)" :key="index">
      <div v-if="isMobile" class="mobile-animation-container">
        <div
          v-if="
            isSport &&
            handleRemoveSpaceSpecialCharFormatted(game.GameName).includes(
              'sbosport'
            )
          "
          class="flex flex-col items-center"
        >
          <div class="">
            <div class="">
              <div class="dm_heading_wrapper">
                <div>{{ game.GameName }}</div>
                <div class="bars">
                  <div v-for="item in 10" :key="item" class="bar"></div>
                </div>
              </div>
              <div class="text-sm content-text-color" v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))">
                {{ $t(game.IntroForDisplay.long) }}
                <br />
                <!-- <br />
                {{ $t("sbo_sport_animated_2") }} -->
              </div>
              <div class="flex justify-center">
                <div
                  class="text-sm btn --primary"
                  @click="
                    authenticated
                      ? handleGameSelected(game)
                      : toggleLoginRegisterDialog()
                  "
                >
                  {{ $t("play_now") }}
                </div>
              </div>
            </div>
            <div class="stage img-parent h-[200px]">
              <img
                class="back-img bounce-1 w-[91%]"
                :src="getAssetImage('assets/theme/common/images/sbo.jpg')"
              />
              <img
                class="sbo-img-front bounce-2 w-[91%] right-[38px] top-0"
                :src="getAssetImage('assets/theme/common/images/sbo-1.png')"
              />
            </div>
          </div>
        </div>
        <div
          v-if="
            isSport &&
            handleRemoveSpaceSpecialCharFormatted(game.GameName).includes(
              'sabasport'
            )
          "
          class="flex justify-center hsport_wrapper saba_bg"
        >
          <div class="px-3">
            <div class="pr-7">
              <div class="dm_heading_wrapper">
                <div>{{ game.GameName }}</div>
                <div class="bars">
                  <div v-for="item in 10" :key="item" class="bar"></div>
                </div>
              </div>
              <div
                class="text-sm leading-relaxed text-justify content-text-color"
                v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
              >
                {{ $t(game.IntroForDisplay.long) }}
              </div>
              <div class="flex justify-center">
                <div
                  class="text-sm btn --primary"
                  @click="
                    authenticated
                      ? handleGameSelected(game)
                      : toggleLoginRegisterDialog()
                  "
                >
                  {{ $t("play_now") }}
                </div>
              </div>
            </div>
            <div class="">
              <div class="stage img-parent">
                <img
                  class="back-img bounce-1"
                  :src="getAssetImage('assets/theme/common/images/ibc.jpg')"
                />
                <img
                  class="ibc-img-front bounce-2"
                  :src="getAssetImage('assets/theme/common/images/ibc-1.png')"
                />
              </div>
            </div>
          </div>
        </div>
        <div v-if="!isSport" class="">
          <div class="">
            <div class="flex flex-col cockfighting">
              <div class="dm_heading_wrapper">
                <div>{{ game.GameNameForDisplay }}</div>
                <div class="bars">
                  <div v-for="item in 10" :key="item" class="bar"></div>
                </div>
              </div>
              <div
                class="text-sm leading-relaxed text-justify cockfight-text-color"
                v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
              >
                {{ $t(game.IntroForDisplay.long) }}
              </div>
              <div class="flex justify-center">
                <div
                  class="text-sm btn --primary"
                  @click="
                    authenticated
                      ? handleGameSelected(game)
                      : toggleLoginRegisterDialog()
                  "
                >
                  {{ $t("play_now") }}
                </div>
              </div>
            </div>
            <div class="w-full">
              <div class="stage img-parent cock-stage">
                <img
                  class="cock-back-img bounce-1"
                  :src="getCockFightImage(game)"
                />
                <img
                  class="cock-img-front-1 bounce-2"
                  :src="
                    getAssetImage(
                      'assets/theme/common/entry/cock_fight/img_float_yb_right.png'
                    )
                  "
                />
                <img
                  class="cock-img-front-2 bounce-2"
                  :src="
                    getAssetImage(
                      'assets/theme/common/entry/cock_fight/img_float_yb_left.png'
                    )
                  "
                />
              </div>
            </div>
          </div>
        </div>
      </div>
      <div v-else class="desktop-animation-container">
        <div v-if="isSport" class="gap-10 mt-[40px]">
          <div
            v-if="index % 2 === 0"
            class="flex flex-col items-center justify-center h-[480px] mb-[40px]"
          >
            <div class="container grid lg:grid-cols-2 grid-cols-1 lg:!w-[1200px] !w-[100%] lg:px-0 px-[10px]">
              <div class="stage img-parent order-2 lg:order-1 lg:inline-block flex justify-center !w-[100%] lg:!h-[360px] !h-auto">
                <img
                  class="back-img bounce-1 lg:w-[600px] lg:!h-[360px] !w-[100%] !h-auto"
                  :src="getAssetImage(`assets/theme/common/${convertString(game.CategoryName)}/${convertString(game.EnglishGameName)}/bg.png`)"
                />
                <img
                  class="sbo-img-front bounce-2 lg:!left-[10px] !inset-x-auto lg:h-[480px] !h-auto"
                  :src="getAssetImage(`assets/theme/common/${convertString(game.CategoryName)}/${convertString(game.EnglishGameName)}/star.png`)"
                />
              </div>
              <div class="flex flex-col leading-relaxed lg:w-[560px] w-[100%] lg:ml-[40px] justify-center order-1 lg:order-2 lg:mt-3 lg:mb-3 lg:mt-3 mt-56 mb-36">
                <div class="dm_heading_wrapper flex flex-wrap lg:!pb-[25px] lg:!mb-[24px] !pb-0 !mb-0">
                  <div class="mb-4 lg:order-1 order-2">{{ game.GameName }}</div>
                  <div class="bars lg:static relative inline-block lg:top-[70px] !top-[-26px] lg:mr-0 mr-[10px] lg:order-2 order-1">
                    <div v-for="item in 10" :key="item" class="bar"></div>
                  </div>
                </div>
                <div class="text-sm content-text-color" v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))">
                  <!-- {{ $t('prefix_sbo_sport_animated_1') }} {{ game.GameProviderName }} {{ $t("sbo_sport_animated_1") }}
                  <br />
                  <br /> -->
                  {{ $t(game.IntroForDisplay.long) }}
                </div>
                <div @click="handleGameSelected(game)"
                  v-if="!checkTheme(selectedTheme)"
                  class="text-sm btn --primary"
                >
                  {{ $t("play_now") }}
                </div>
                <div
                  v-if="checkTheme(selectedTheme)"
                  class="text-sm btn --primary"
                  @click="handleGameSelected(game)"
                >
                  {{ $t("play_now") }}
                </div>
              </div>
            </div>
          </div>
          <div
            v-else
            :class="[
              'flex justify-center hsport_wrapper items-center lg:px-0 px-[10px] !w-full',
              handleRemoveSpaceSpecialCharFormatted(game.GameName).includes(
                'sbosport'
              )
                ? 'mt-20'
                : 'mt-0',
            ]"
          >
            <div class="container flex flex-row flex-wrap lg:flex-nowrap justify-between gap-11 items-center lg:h-[480px] lg:px-0 px-[10px]">
              <div class="flex flex-col justify-center lg:pt-3 pt-52 lg:!mb-3 mb-36">
                <div class="dm_heading_wrapper flex flex-wrap lg:!pb-[25px] lg:!mb-[24px] !pb-0 !mb-0">
                  <div class="mb-4 lg:order-1 order-2">{{ game.GameName }}</div>
                  <div class="bars lg:static relative inline-block lg:top-[70px] !top-[-26px] lg:mr-0 mr-[10px] lg:order-2 order-1">
                    <div v-for="item in 10" :key="item" class="bar"></div>
                  </div>
                </div>
                <div
                  class="text-sm leading-relaxed text-justify content-text-color"
                  v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
                >
                  {{ $t(game.IntroForDisplay.long) }}
                </div>
                <nuxt-link
                  v-if="!checkTheme(selectedTheme)"
                  @click="handleGameSelected(game)"
                  class="text-sm btn --primary"
                >
                  {{ $t("play_now") }}
                </nuxt-link>
                <div
                  v-if="checkTheme(selectedTheme)"
                  class="text-sm btn --primary"
                  @click="handleGameSelected(game)"
                >
                  {{ $t("play_now") }}
                </div>
              </div>
              <div class="lg:!w-1/2 w-[100%]">
                <div class="stage img-parent lg:!w-[600px] lg:!h-[360px] !w-[100%] flex justify-center lg:!h-[360px] !h-auto">
                  <img
                    class="back-img bounce-1 !w-[100%] !h-auto"
                    :src="getAssetImage(`assets/theme/common/${convertString(game.CategoryName)}/${convertString(game.EnglishGameName)}/bg.png`)"
                  />
                  <img
                    class="ibc-img-front bounce-2 lg:left-[10px] !inset-x-auto"
                    :src="getAssetImage(`assets/theme/common/${convertString(game.CategoryName)}/${convertString(game.EnglishGameName)}/star.png`)"
                  />
                </div>
              </div>
            </div>
          </div>
        </div>
        <div v-if="!isSport" class="flex flex-col items-center">
          <div
            v-if="index % 2 === 0"
            class="flex flex-col items-center justify-center h-[480px] mb-[40px]"
          >
            <div class="container grid grid-cols-2">
              <div class="cockfighting flex flex-col w-[545.83px] h-[406px] pr-7">
                <div class="dm_heading_wrapper">
                  <div>{{ game.GameProviderDisplayName }}</div>
                  <div class="bars">
                    <div v-for="item in 10" :key="item" class="bar"></div>
                  </div>
                </div>
                <div
                  class="text-sm leading-relaxed text-justify content-text-color"
                  v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
                >
                  {{ $t(game.IntroForDisplay.long) }}
                </div>
                <nuxt-link
                  v-if="!checkTheme(selectedTheme)"
                  :to="
                    authenticated
                      ? `/Game/${game.GameId}?tab=cockfight&&entrance=${EnumEntranceLocation.GameLobby}`
                      : '/login'
                  "
                  class="text-sm btn --primary"
                >
                  {{ theme === 'bk8' ? convertFirstUpperCase($t("play_now")) : $t("play_now") }}
                </nuxt-link>
                <div
                  v-if="checkTheme(selectedTheme)"
                  class="text-sm btn --primary"
                  @click="handleGameSelected(game)"
                >
                {{ theme === 'bk8' ? convertFirstUpperCase($t("play_now")) : $t("play_now") }}
                </div>
              </div>
              <div class="w-full">
                <div class="stage img-parent">
                  <img
                    class="cock-back-img bounce-1"
                    :src="getCockFightImage(game)"
                  />
                  <img
                    class="cock-img-front-1 bounce-2"
                    :src="
                      getAssetImage(
                        'assets/theme/common/entry/cock_fight/img_float_yb_right.png'
                      )
                    "
                  />
                  <img
                    class="cock-img-front-2 bounce-2"
                    :src="
                      getAssetImage(
                        'assets/theme/common/entry/cock_fight/img_float_yb_left.png'
                      )
                    "
                  />
                </div>
              </div>
            </div>
          </div>
          <div v-else>
            <div class="container grid grid-cols-2">
              <div class="w-full">
                <div class="stage img-parent">
                  <img
                    class="cock-back-img bounce-1"
                    :src="getCockFightImage(game)"
                  />
                  <img
                    class="cock-img-front-1 bounce-2"
                    :src="
                      getAssetImage(
                        'assets/theme/common/entry/cock_fight/img_float_yb_right.png'
                      )
                    "
                  />
                  <img
                    class="cock-img-front-2 bounce-2"
                    :src="
                      getAssetImage(
                        'assets/theme/common/entry/cock_fight/img_float_yb_left.png'
                      )
                    "
                  />
                </div>
              </div>
              <div class="cockfighting flex flex-col w-[545.83px] h-[406px] pr-7 pl-24">
                <div class="dm_heading_wrapper">
                  <div>{{ game.GameNameForDisplay }}</div>
                  <div class="bars">
                    <div v-for="item in 10" :key="item" class="bar"></div>
                  </div>
                </div>
                <div
                  class="text-sm leading-relaxed text-justify content-text-color"
                  v-if="!checkIncludeUnderScore($t(game.IntroForDisplay.long))"
                >
                  {{ $t(game.IntroForDisplay.long) }}
                </div>
                <nuxt-link
                  v-if="!checkTheme(selectedTheme)"
                  :to="
                    authenticated
                      ? `/Game/${game.GameId}?tab=cockfight&&entrance=${EnumEntranceLocation.GameLobby}`
                      : '/login'
                  "
                  class="text-sm btn --primary"
                >
                  {{ theme === 'bk8' ? convertFirstUpperCase($t("play_now")) : $t("play_now") }}
                </nuxt-link>
                <div
                  v-if="checkTheme(selectedTheme)"
                  class="text-sm btn --primary"
                  @click="handleGameSelected(game)"
                >
                {{ theme === 'bk8' ? convertFirstUpperCase($t("play_now")) : $t("play_now") }}
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <common-login-dialog v-if="!isMobile" v-model="dialog" />
  </div>
  <div v-else>
    <lobby-no-game-message />
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { computed, defineComponent, ref } from "vue";
import {
  handleGameEntryOpenWindow,
  useGameEntryBaseOnTabSelected,
} from "@/composables/useTheme";
import { store } from "@/store";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import commonHelper from "@/utils/commonHelper";
import textHelper from "@/utils/formatHelpers/textFormatHelper";
import { IGameBsi } from "~~/models/bsiGameList";
import SportDisplayModel from "../sport/sportDisplayModel";
import CockFightDisplayModel from "~~/models/cockFightModel";
import { IGame } from "@/models/IGetPlayableGamesResponse";

export default defineComponent({
  name: "GameListAnimation",
  props: {
    isSport: {
      type: Boolean,
      default: true,
    },
  },
  setup() {
    const router = useRouter();
    const authenticated = computed(() => store.state.auth);
    const isGameLoading = computed(() => store.state.isGameUpdateLoading);
    const { gameEntrySelected } = useGameEntryBaseOnTabSelected();
    const gameFiltered = (game: string, expected: string): boolean =>
      _.includes(_.toLower(_.replace(game, " ", "")), expected);
    const filteredGameEntrySelected = computed(() =>
      _.filter(
        gameEntrySelected.value,
        (sport) =>
          sport !== undefined &&
          (gameFiltered(sport.GameName, "sbosport") ||
            gameFiltered(sport.GameName, "sabasport") ||
            gameFiltered(sport.GameName, "cockfight") ||
            gameFiltered(sport.GameName, "sv388cockfighting"))
      )
    );
    const tabTypeForRoute = computed(() => {
      let result = "";
      gameEntrySelected.value.forEach((item) => {
        if (item?.TabType !== undefined) {
          result = item?.TabType.replaceAll(" ", "-").toLowerCase();
        }
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.GameLobby}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.GameLobby}`;
    });
    const selectedTheme = store.state.selectedThemeName;
    const dialog = ref(false);
    const checkTheme = (name: string) => {
      if (name === "blue_sbo_desktop_3") {
        return true;
      }
      return false;
    };
    const isMobile = !useIsDesktop();
    const handleGameSelected = (game: IGame) => {
      if (authenticated.value) {
        if (!isMobile) {
          if (game.GameId === 74) handleGameEntryOpenWindow(game, 1200, 850, EnumEntranceLocation.GameLobby);
          else router.push(`/Game/${game.GameId}${tabTypeForRoute.value}`);
        } else {
          handleGameEntryOpenWindow(game, 850, 850);
        }
      } else {
        if (!isMobile) router.push("/login");
        else dialog.value = true;
      }
    };
    const { getAssetImage, handleRemoveSpaceSpecialCharFormatted, toggleLoginRegisterDialog } =
      commonHelper;
    const sabaBgUrl = isMobile
      ? "assets/theme/common/images/mobilesabasportsbgcontainer.jpg"
      : "assets/theme/common/images/sabasportsbgcontainer.jpg";
    const sabaBg = `url(${getAssetImage(sabaBgUrl)})`;
    const { themeColor } = themePropertyHelper;
    const  theme  = themeColor.value.Text ;
    const convertFirstUpperCase = (text:string) => {
      const words = text.toLowerCase().split(' ');
      const capitalizedWords = words.map(word => {
        return word.charAt(0).toUpperCase() + word.slice(1);
      });

      // Join the capitalized words into a single string with spaces between them
      return capitalizedWords.join(' ');
    }
    const { convertString } = textHelper;
    const checkIncludeUnderScore = (text: string) => {
      if (text.includes('_')) return true;
      return false;
    };
    const getCockFightImage = (game: IGameBsi) => {
      const imageForDisplay = computed(() => new CockFightDisplayModel(game));
      const startImage = imageForDisplay.value.StarImagePath;
      return startImage;
    }
    return {
      authenticated,
      isGameLoading,
      gameEntrySelected,
      filteredGameEntrySelected,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      handleGameSelected,
      checkTheme,
      selectedTheme,
      dialog,
      handleRemoveSpaceSpecialCharFormatted,
      getAssetImage,
      sabaBg,
      isMobile,
      theme,
      convertFirstUpperCase,
      convertString,
      checkIncludeUnderScore,
      toggleLoginRegisterDialog,
      getCockFightImage,
    };
  },
});
</script>
<style scoped>
.dm_heading_wrapper {
  color: var(--primary);
  font-size: 24px;
  font-weight: 500;
  padding-bottom: 25px;
  margin-bottom: 24px;
  position: relative;
  text-transform: uppercase;
}
.btn {
  @apply inline-block text-center rounded-2xl text-white duration-300;
  min-width: 160px;
  margin-right: 1rem;
  width: 160px;
  margin-top: 24px;
  padding: 8px 20px;
}
.stage {
  display: flex;
  height: 360px;
  width: 600px;
}
.back-img {
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  height: 360px;
  transform-origin: bottom;
  width: 600px;
  position: relative;
  top: 0;
  right: 0;
}
.bounce-1 {
  animation-name: bounce-1;
  animation-timing-function: linear;
}
@keyframes bounce-1 {
  0% {
    transform: translateY(0);
  }
  50% {
    transform: translateY(-10px);
  }
  100% {
    transform: translateY(0);
  }
}
.bounce-2 {
  animation-name: bounce-2;
  animation-timing-function: linear;
}
@keyframes bounce-2 {
  0% {
    transform: translateY(0);
  }
  50% {
    transform: translateY(9px);
  }
  100% {
    transform: translateY(0);
  }
}
.bars {
  left: 2px;
  top: 70px;
  width: 40px;
}

.bar {
  background: var(--primary);
  bottom: 1px;
  height: 3px;
  position: absolute;
  width: 3px;
  animation: sound 0ms -800ms linear infinite alternate;
}

@keyframes sound {
  0% {
    opacity: 0.35;
    height: 3px;
  }
  100% {
    opacity: 1;
    height: 28px;
  }
}

.bar:nth-child(1) {
  left: 1px;
  animation-duration: 474ms;
}
.bar:nth-child(2) {
  left: 5px;
  animation-duration: 433ms;
}
.bar:nth-child(3) {
  left: 9px;
  animation-duration: 407ms;
}
.bar:nth-child(4) {
  left: 13px;
  animation-duration: 458ms;
}
.bar:nth-child(5) {
  left: 17px;
  animation-duration: 400ms;
}
.bar:nth-child(6) {
  left: 21px;
  animation-duration: 427ms;
}
.bar:nth-child(7) {
  left: 25px;
  animation-duration: 441ms;
}
.bar:nth-child(8) {
  left: 29px;
  animation-duration: 419ms;
}
.bar:nth-child(9) {
  left: 33px;
  animation-duration: 487ms;
}
.bar:nth-child(10) {
  left: 37px;
  animation-duration: 442ms;
}

.hsport_wrapper {
  background-position: center 0;
  background-size: cover;
  padding-top: 44px;
  padding-bottom: 44px;
  width: 100%;
  width: 100vw;
  position: relative;
  left: 50%;
  right: 50%;
  margin-left: -50vw;
  margin-right: -50vw;
}
.desktop-animation-container .saba_bg {
  background: v-bind("sabaBg");
}
.sbo-img-front {
  position: absolute;
  top: -70px;
  left: 10px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
  width: 590px;
  height: 480px;
}
.ibc-img-front {
  position: absolute;
  top: -60px;
  left: 10px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
}
.cock-back-img {
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  height: 461px;
  transform-origin: bottom;
  width: 553px;
  position: relative;
  top: 0;
  right: 0;
}
.cock-img-front-1 {
  position: absolute;
  top: -30px;
  left: 392px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
  height: 510px;
  width: 260px;
}
.cock-img-front-2 {
  position: absolute;
  top: -70px;
  left: -95px;
  align-self: flex-end;
  animation-duration: 3s;
  animation-iteration-count: infinite;
  transform-origin: bottom;
  height: 510px;
  width: 260px;
}
.img-parent {
  position: relative;
  top: 0;
  left: 0;
}
</style>
<style lang="scss" scoped>
.mobile-animation-container {
  .img-parent {
    height: 200px;
    margin-top: 127px;
    .back-img {
      width: 91%;
      height: auto;
    }
    .sbo-img-front {
      width: 84%;
      left: 28px;
      top: -115px;
    }
    .ibc-img-front {
      width: 83%;
      left: 33px;
      top: -120px;
    }
    .cock-back-img {
      width: 100%;
      height: auto;
      left: -39px;
      top: -113px;
      position: absolute;
    }
    .cock-img-front-1 {
      width: 38%;
      height: auto;
      left: 213px;
      top: -147px;
    }
    .cock-img-front-2 {
      width: 38%;
      height: auto;
      left: 0;
      top: -147px;
    }
  }
  .img-parent.cock-stage {
    width: 100%;
  }
  .hsport_wrapper {
    padding-top: 10px;
    padding-bottom: 20px;
  }
  .saba_bg {
    background-image: v-bind("sabaBg");
  }
}

.content-text-color {
  color: var(--text);
}
.game-content-white .content-text-color {
  color: var(--text2);
}
[theme-color="bk8"] .btn {
  width: 320px;
  height: 36px;
  border-radius:4px;
}
</style>
